﻿using System;
using Microsoft.AspNetCore.Mvc.ApplicationModels;

namespace StudioX.AspNetCore.Configuration
{
    public class StudioXControllerAssemblySettingBuilder : IStudioXControllerAssemblySettingBuilder
    {
        private readonly StudioXControllerAssemblySetting setting;

        public StudioXControllerAssemblySettingBuilder(StudioXControllerAssemblySetting setting)
        {
            this.setting = setting;
        }

        public StudioXControllerAssemblySettingBuilder Where(Func<Type, bool> predicate)
        {
            setting.TypePredicate = predicate;
            return this;
        }

        public StudioXControllerAssemblySettingBuilder ConfigureControllerModel(Action<ControllerModel> configurer)
        {
            setting.ControllerModelConfigurer = configurer;
            return this;
        }
    }
}