﻿using StudioX.Timing;

namespace StudioX.Extensions
{
    /// <summary>
    ///     Extension methods for <see cref="IDateTimeRange" />.
    /// </summary>
    public static class DateTimeRangeExtensions
    {
        /// <summary>
        ///     Sets date range to given target.
        /// </summary>
        /// <param name="source"></param>
        /// <param name="target"></param>
        public static void SetTo(this IDateTimeRange source, IDateTimeRange target)
        {
            target.StartTime = source.StartTime;
            target.EndTime = source.EndTime;
        }

        /// <summary>
        ///     Sets date range from given source.
        /// </summary>
        public static void SetFrom(this IDateTimeRange target, IDateTimeRange source)
        {
            target.StartTime = source.StartTime;
            target.EndTime = source.EndTime;
        }
    }
}